Subject: Re: psc and spi

From: "S. Fricke" <[email-masked]>
Date: Wed, 2 Apr 2008 15:06:45 +0200

Hello,

> On 1/15/08, S. Fricke <[email-masked]> wrote:
> > Hello friends,
> >
> > I have on the psc3 the spi-interface of a fpga connected.
> >
> >    psc3-0 - MOSI
> >    psc3-1 - MISO
> >    psc3-2 - CLK
> >    psc3-3 - SlaveSelect
> >    psc3-4 - CS-FPGA
> >    psc3-5 - CS Another device
> >    psc3-6 - SPI-SEL0
> >    psc3-7 - SPI-SEL1
> >    psc3-8/9 - Not connected
> >
> > Can I use the mpc52xx_psc_spi-driver? And if yes, how I have to use this
> > driver?  Or must I write a own spi-master/slave thing? Can anyone point me
> > to a good start-position?
> 
> Yes, you should be able to use the mpc52xx_psc_spi driver.  You'' need
> to add the activate_cs and deactivate_cs hooks in your platform code
> to activate your SPI CS lines.  You'll also need to set port_config to
> have the PSC3 pins in "CODEC3" mode.

OK, I defined a "fsl_spi_platform_data" for my "activate_cs" and 
"deactivate_cs". This structure I have insert in a "spi_board_info" with
all other mandatory Informations.
When I load "mpc52xx_psc_spi", then I get a "mpc52xx-psc-spi f0002400.spi:
probe called without platform data, no (de)activate_cs function will be
called"

What is wrong in my setup or did I have forget something?

    static void activate_cs(u8 cs, u8 polarity) {/* ... */ }
    static void deactivate_cs(u8 cs, u8 polarity) {/* ...*/}

    static struct fsl_spi_platform_data my_spi_p_data = { 
        .bus_num = 0x2400,
        .max_chipselect = 3,
        .activate_cs = activate_cs,
        .deactivate_cs = deactivate_cs,
    };  
    static struct spi_board_info my_spi_boardinfo = { 
        .bus_num = 0x2400,
        .chip_select = 0,
        .max_speed_hz = 1000,
        .modalias = "my-spi-device",
        .platform_data = &my_spi_p_data,
    };  

    static int __init ipek01_spi_init(void) {
        int ret;
        return fsl_spi_init(&my_spi_boardinfo, 1, activate_cs, deactivate_cs);
    }   
    device_initcall(ipek01_spi_init);

best regards,
Silvio Fricke

-- 
-- S. Fricke ------------------------------------ [email-masked] --
   Diplom-Informatiker (FH)         TEL:                 (+49)8330-911278
   Linux-Entwicklung             JABBER: [email-masked]
----------------------------------------------------------------------------